mod Ex02a

incl Mtex

incl Mtexrc

incl Mauxa

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU M-INBP-004 TEORIA VYPOCITATELNOSTI PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 28.9.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INBP-004-vyp/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam (zakladny vyvoj, parovacia funkcia). Zadanie sa sklada z 
  tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 2 = 1+1 
   \item \para Pocet bodov za premiove ulohy v tomto subore:: 0 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/M-INBP-004/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 3.10.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  Primitive recursive functions.  \end See also the module 
  \ft Mauxa \end. 

rem 
  \para \bf  Exercise.  \end Find a primitive recursive (p.r.) derivation of the 
  following unary constant functions 
  \eq* 
    C1(x) = 1
  \end
  \eq* 
    C2(x) = 2
  \end
  \eq* 
    C3(x) = 3
  \end

fun C1 
  C1(x) = Foo

fun C2 
  C2(x) = Foo

fun C3 
  C3(x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/3 H_plus 'Tex_f3_h' \end Find a p.r. 
  derivation of the ternary function \ft Texm_f0_h \end explicitly defined by 
  \eq* 
    H_plus(x,a,y) = Ss(a)
  \end

fun/3 H_plus 'Tex_f3_h'
  H_plus(x,a,y) = Foo

rem 
  \para \bf  Exercise.  \end Find a p.r. derivation of the addition function 
  \ft x+y \end. 

fun/2 Plus 'Tex_f2_n_plus'
  Plus(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Find a p.r. derivation of the multiplication 
  function \ft x*y \end. 

fun/2 Times 'Tex_f2_n_times'
  Times(x,y) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Find a p.r. derivation 
  of the exponentiation function \ft Texm_f2_n_exp(x,y) \end. 

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,y) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Find a `short' primitive 
  recursive derivation of the constant function 
  \eq* 
    C27(x) = 27
  \end

fun C27 
  C27(x) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

