mod Ex02c

incl Mtex

incl Mtexrc

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU M-INBP-004 TEORIA VYPOCITATELNOSTI PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 28.9.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INBP-004-vyp/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam (zakladny vyvoj, parovacia funkcia). Zadanie sa sklada z 
  tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 1 
   \item \para Pocet bodov za premiove ulohy v tomto subore:: 0 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/M-INBP-004/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 3.10.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Subsection. Pairing Function.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun Sum 'Tex_f1_n_sum' \end Show that the 
  summation function \ft Sum(n) \end is primitive recursive. 

fun Sum 'Tex_f1_n_sum'
  Sum(n) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Pair 'Tex_f2_pp_pair' \end Show that 
  the modified Cantor's pairing function \ft Pair(x,y) \end is primitive 
  recursive. 

fun/2 Pair 'Tex_f2_pp_pair'
  Pair(x,y) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Proj1 'Tex_f1_pp_proj1' \end Show that 
  the first projection \ft Proj1(x) \end of the pairing function is primitive 
  recursive. 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Proj2 'Tex_f1_pp_proj2' \end Show that 
  the second projection \ft Proj2(x) \end of the pairing function is primitive 
  recursive. 

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(x) = Foo

rem 
  \para \bf  Exercise.  \end Show that unary iteration of the second projection 
  function is a p.r. function. 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(n,x) = Foo

rem 
  \para \bf  Exercise.  \end Show that the sequence length function 
  \ft L(x) \end is primitive recursive. 

fun L 
  L(x) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun/2 Sub 'Tex_f2_ln_sub' \end Show that the indexing function 
  \ft Sub(x,i) \end is primitive recursive. 

fun/2 Sub 'Tex_f2_ln_sub'
  Sub(x,i) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun Fib 'Tex_f1_n_fib' \end The Fibonacci function \ft Fib(n) \end 
  has the following course of values recursive definition: 

fun Fib 'Tex_f1_n_fib'
  Fib(0) = 0
  Fib(1) = 1
  Fib(n+2) = Fib(n+1)+Fib(n)

rem 
  \para Derive Fibonacci sequence as a p.r. function by showing that the 
  function 
  \eq* 
    F(n) = Pair(Fib(n),Fib(n+1))
  \end
  \para is primitive recursive. 

fun F 
  F(n) = Foo

fun Fib_is_primrec 'Tex_f1_n_fib'
  Fib_is_primrec(n) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

fun Elem 
  Elem(n) = 0

fun/2 Seqa 
  Seqa(0,a) = a
  Seqa(n+1,a) = Seqa(n,Pair(Elem(n),a))

fun Seq 
  Seq(n) = Seqa(n,0)

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

