mod Ex02b

incl Mtex

incl Mtexrc

incl Mauxb

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU M-INBP-004 TEORIA VYPOCITATELNOSTI PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 28.9.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INBP-004-vyp/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam (zakladny vyvoj, parovacia funkcia). Zadanie sa sklada z 
  tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 2 
   \item \para Pocet bodov za premiove ulohy v tomto subore:: 0 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/M-INBP-004/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 3.10.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  Primitive recursive functions.  \end See also the module 
  \ft Mauxb \end. 

rem 
  \para \bf  Explicit definitions of functions.  \end 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  explicit definitions of functions. 

rem 
  \para \bf  Primitive recursive definitions.  \end 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  primitive recursive definitions. 

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Prove the previous 
  theorem for the special case in the next theory. 

theory Parameterless_primitive_recursive_definition

fun/0 Tau1 'Tex0_tau1'

fun/2 Tau2 'Tex_f2_tau2_subst'

rem 
  \para \header* fun F 'Tex_f1_f' \end Suppose that \ft Tau1 \end and 
  \ft Tau2(x,a) \end are terms with the only indicated variables free and such 
  that they apply only p.r. functions. Show that the unary function 
  \ft Texm_f0_f \end defined by the primitive recursive definition 
  \eq* 
    F(0) = Tau1
  \end
  \eq* 
    F(x+1) = Tau2(x,F(x))
  \end
  \para is primitive recursive. 

fun F 'Tex_f1_f'
  F(x) = Foo

end theory Parameterless_primitive_recursive_definition

rem 
  \para \bf  Exercise.  \end Show that the addition function \ft x+y \end is 
  primitive recursive. 

fun/2 Plus 'Tex_f2_n_plus'
  Plus(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x+y \end. 

rem 
  \para \bf  Exercise.  \end Show that the multiplication function \ft x*y \end 
  is primitive recursive. 

fun/2 Times 'Tex_f2_n_times'
  Times(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x*y \end. 

rem 
  \para \bf  Exercise.  \end Show that the exponentiation function 
  \ft Texm_f2_n_exp(x,y) \end is primitive recursive. 

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Show that the predecessor function \ft x-1 \end is 
  primitive recursive. 

fun Pred 'Tex_f1_rec_pred'
  Pred(x) = Foo

rem 
  \para \bf  Exercise.  \end Show that the modified subtraction function 
  \ft x-y \end is primitive recursive. 

fun/2 Minus 'Tex_f2_n_minus'
  Minus(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x-y \end. 

rem 
  \para \bf  Exercise.  \end \header* fun/3 D1 'Tex_f3_rec_d1' \end Show that 
  the case discrimination function \ft D1(x,y,z) \end is primitive recursive. 

fun/3 D1 'Tex_f3_rec_d1'
  D1(x,y,z) = Foo

rem 
  \para \it  [CL] Remark.  \end In the sequel do not use the `function' 
  \ft D \end from the module \it  Standard  \end; it plays the role of 
  if-then-else construct. 

rem 
  \para \bf  Exercise.  \end Show that the equality predicate \ft x = y \end is 
  primitive recursive. 

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Show that primitive 
  recursive functions are closed under the operator of bounded minimalization. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Operator_of_bounded_minimalization

fun/2 G 'Tex_f2_g'

rem 
  \para \header* fun/2 F 'Tex_f2_f' \end Suppose that \ft G(z,y) \end is a p.r. 
  function. Show that function \ft F(x,y) \end defined as 
  \def 
    fun/2 F 'Tex_f2_f'
    F(x,y) = \m z <= x [ G(z,y) = 1 ]
  \end
  \para is primitive recursive. 

fun/2 F 'Tex_f2_f'
  F(x,y) = Foo

end theory Operator_of_bounded_minimalization

rem 
  \para \bf  Exercise.  \end Show that the boolean functions are primitive 
  recursive. 

fun Notf 'Tex_f1_bool_notf'
  Notf(x) = Foo

fun/2 Andf 'Tex_f2_bool_andf'
  Andf(x,y) = Foo

fun/2 Orf 'Tex_f2_bool_orf'
  Orf(x,y) = Foo

fun/2 Impf 'Tex_f2_bool_impf'
  Impf(x,y) = Foo

fun/2 Ifff 'Tex_f2_bool_ifff'
  Ifff(x,y) = Foo

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  explicit definitions of predicates. 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under under 
  definitions of functions with bounded minimalization. 

rem 
  \para \bf  Corollary.  \end Comparison predicates are primitive recursive. 

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin comparison 
  predicates. 

rem 
  \para \bf  Exercise.  \end Show that the integer division function 
  \ft x/y \end is primitive recursive. Recall that \ft x/0 = 0 \end. 

fun/2 Div 'Tex_f2_n_div'
  Div(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x/y \end. 

rem 
  \para \bf  Exercise.  \end Show that the remainder function \ft x mod y \end 
  is primitive recursive. Recall that \ft x mod 0 = 0 \end. 

fun/2 Mod 'Tex_f2_n_mod'
  Mod(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x mod y \end. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

